/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pos;

import com.ustasoft.component.GeneralFunction;
import com.ustasoft.component.Konfigurasi;
import com.ustasoft.config.InformasiPerusahaan;
import com.ustasoft.config.KonfigurasiSistemDao;
import com.ustasoft.config.SettingKoneksi;
import com.ustasoft.config.SettingMenu;
import com.ustasoft.config.SettingPenjualan;
import com.ustasoft.pos.dao.jdbc.AccCoaDao;
import com.ustasoft.pos.dao.jdbc.GudangDao;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.FocusTraversalPolicy;
import java.awt.KeyboardFocusManager;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.JTextField;

/**
 *
 * @author ustadho
 */
public class FrmKonfigurasiSistem extends javax.swing.JInternalFrame {

    private GeneralFunction fn = GeneralFunction.getInstance();
    ResultSet rsPenjualan;
    AccCoaDao coaDao = new AccCoaDao(MainForm.conn);
    GudangDao gudangDao = new GudangDao(MainForm.conn);
    InformasiPerusahaan informasiPerusahaan = null;
    SettingPenjualan settingPenjualan = null;
    SettingKoneksi settingKoneksi = null;
    List<SettingMenu> oldList = new ArrayList<>();
    KonfigurasiSistemDao konfigurasiSistemDao = new KonfigurasiSistemDao();

    /**
     * Creates new form FrmKonfigurasiSistem
     */
    public FrmKonfigurasiSistem() {
        initComponents();

        MyKeyListener kListener = new MyKeyListener();
        fn.addKeyListenerInContainer(panelInformasiUsahaDetail, kListener, txtFocusListener);
        btnSave.addKeyListener(kListener);
        btnKeluar.addKeyListener(kListener);

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTabbedPane1 = new javax.swing.JTabbedPane();
        panelInformasiUsaha = new javax.swing.JPanel();
        panelInformasiUsahaDetail = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        txtNamaUsaha = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        txtAlamat1 = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        txtAlamat2 = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        txtKota = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        txtTelp1 = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        txtTelp2 = new javax.swing.JTextField();
        lblAkunLabaDitahan = new javax.swing.JLabel();
        txtEmail = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        txtAkunLabaDitahan = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        chkTglServer = new javax.swing.JCheckBox();
        chkStatusShift = new javax.swing.JCheckBox();
        chkTampilkanHpp = new javax.swing.JCheckBox();
        chkTutupDialogBayar = new javax.swing.JCheckBox();
        lblKota = new javax.swing.JLabel();
        panelPenjualan = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jLabel17 = new javax.swing.JLabel();
        jLabel18 = new javax.swing.JLabel();
        jLabel19 = new javax.swing.JLabel();
        txtDibuatOleh = new javax.swing.JTextField();
        jLabel20 = new javax.swing.JLabel();
        txtDiperiksaOleh = new javax.swing.JTextField();
        jLabel21 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtKetPembayaran = new javax.swing.JTextArea();
        txtDisiapkanOleh = new javax.swing.JTextField();
        jScrollPane2 = new javax.swing.JScrollPane();
        txtCatatanKaki = new javax.swing.JTextArea();
        jLabel22 = new javax.swing.JLabel();
        jSpinnerJumlahCetak = new javax.swing.JSpinner();
        btnSave = new javax.swing.JButton();
        btnKeluar = new javax.swing.JButton();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Konfigurasi Sistem");
        addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
                formInternalFrameOpened(evt);
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
        });
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        panelInformasiUsaha.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panelInformasiUsaha.setLayout(null);

        panelInformasiUsahaDetail.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        panelInformasiUsahaDetail.setLayout(null);

        jLabel1.setText("Nama Perusahaan : ");
        panelInformasiUsahaDetail.add(jLabel1);
        jLabel1.setBounds(10, 10, 130, 20);

        txtNamaUsaha.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelInformasiUsahaDetail.add(txtNamaUsaha);
        txtNamaUsaha.setBounds(140, 10, 360, 22);

        jLabel2.setText("Alamat 1 :");
        panelInformasiUsahaDetail.add(jLabel2);
        jLabel2.setBounds(10, 35, 130, 20);

        txtAlamat1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelInformasiUsahaDetail.add(txtAlamat1);
        txtAlamat1.setBounds(140, 35, 360, 22);

        jLabel3.setText("Alamat 2 :");
        panelInformasiUsahaDetail.add(jLabel3);
        jLabel3.setBounds(10, 60, 130, 20);

        txtAlamat2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelInformasiUsahaDetail.add(txtAlamat2);
        txtAlamat2.setBounds(140, 60, 360, 22);

        jLabel4.setText("Kota : ");
        panelInformasiUsahaDetail.add(jLabel4);
        jLabel4.setBounds(10, 85, 130, 20);

        txtKota.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        txtKota.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                txtKotaKeyReleased(evt);
            }
        });
        panelInformasiUsahaDetail.add(txtKota);
        txtKota.setBounds(140, 85, 60, 22);

        jLabel5.setText("Telp 1 : ");
        panelInformasiUsahaDetail.add(jLabel5);
        jLabel5.setBounds(10, 110, 130, 20);

        txtTelp1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelInformasiUsahaDetail.add(txtTelp1);
        txtTelp1.setBounds(140, 110, 360, 22);

        jLabel6.setText("Telp 2 : ");
        panelInformasiUsahaDetail.add(jLabel6);
        jLabel6.setBounds(10, 135, 130, 20);

        txtTelp2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelInformasiUsahaDetail.add(txtTelp2);
        txtTelp2.setBounds(140, 135, 360, 22);

        lblAkunLabaDitahan.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelInformasiUsahaDetail.add(lblAkunLabaDitahan);
        lblAkunLabaDitahan.setBounds(200, 195, 300, 22);

        txtEmail.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelInformasiUsahaDetail.add(txtEmail);
        txtEmail.setBounds(140, 160, 360, 22);

        jLabel8.setText("Email : ");
        panelInformasiUsahaDetail.add(jLabel8);
        jLabel8.setBounds(10, 160, 130, 20);

        txtAkunLabaDitahan.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        txtAkunLabaDitahan.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                txtAkunLabaDitahanKeyReleased(evt);
            }
        });
        panelInformasiUsahaDetail.add(txtAkunLabaDitahan);
        txtAkunLabaDitahan.setBounds(140, 195, 60, 22);

        jLabel9.setText("Akun Laba Ditahan :");
        panelInformasiUsahaDetail.add(jLabel9);
        jLabel9.setBounds(10, 195, 130, 20);

        chkTglServer.setText("Semua Tanggal Transaksi menggunakan tanggal server");
        panelInformasiUsahaDetail.add(chkTglServer);
        chkTglServer.setBounds(140, 230, 380, 18);

        chkStatusShift.setText("Menggunakan shift");
        panelInformasiUsahaDetail.add(chkStatusShift);
        chkStatusShift.setBounds(140, 270, 180, 18);

        chkTampilkanHpp.setText("Tampilkan HPP di form Penjualan");
        panelInformasiUsahaDetail.add(chkTampilkanHpp);
        chkTampilkanHpp.setBounds(140, 250, 360, 20);

        chkTutupDialogBayar.setText("Tutup dialog Pembayaran setelah Simpan");
        panelInformasiUsahaDetail.add(chkTutupDialogBayar);
        chkTutupDialogBayar.setBounds(310, 270, 300, 18);

        lblKota.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelInformasiUsahaDetail.add(lblKota);
        lblKota.setBounds(200, 85, 300, 22);

        panelInformasiUsaha.add(panelInformasiUsahaDetail);
        panelInformasiUsahaDetail.setBounds(10, 10, 650, 300);

        jTabbedPane1.addTab("Informasi Usaha", panelInformasiUsaha);

        panelPenjualan.setLayout(null);

        jPanel6.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel6.setLayout(null);

        jLabel17.setText("Catatan Kaki");
        jPanel6.add(jLabel17);
        jLabel17.setBounds(10, 160, 120, 20);

        jLabel18.setText("Disiapkan Oleh");
        jPanel6.add(jLabel18);
        jLabel18.setBounds(10, 10, 120, 20);

        jLabel19.setText("Dibuat Oleh");
        jPanel6.add(jLabel19);
        jLabel19.setBounds(10, 35, 120, 20);

        txtDibuatOleh.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel6.add(txtDibuatOleh);
        txtDibuatOleh.setBounds(130, 35, 360, 22);

        jLabel20.setText("Diperiksa Oleh");
        jPanel6.add(jLabel20);
        jLabel20.setBounds(10, 60, 120, 20);

        txtDiperiksaOleh.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel6.add(txtDiperiksaOleh);
        txtDiperiksaOleh.setBounds(130, 60, 360, 22);

        jLabel21.setText("Ket. Pembayaran");
        jPanel6.add(jLabel21);
        jLabel21.setBounds(10, 90, 120, 20);

        txtKetPembayaran.setColumns(20);
        txtKetPembayaran.setRows(5);
        txtKetPembayaran.setText("Pembayaran dengan Transfer, BG/ Cheque,\ndapat ditujukan ke BCA Citraland - Surabaya\nNo. Rek. 8620022200 a/n MARISA");
        jScrollPane1.setViewportView(txtKetPembayaran);

        jPanel6.add(jScrollPane1);
        jScrollPane1.setBounds(130, 90, 360, 70);

        txtDisiapkanOleh.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        jPanel6.add(txtDisiapkanOleh);
        txtDisiapkanOleh.setBounds(130, 10, 360, 22);

        txtCatatanKaki.setColumns(20);
        txtCatatanKaki.setRows(5);
        jScrollPane2.setViewportView(txtCatatanKaki);

        jPanel6.add(jScrollPane2);
        jScrollPane2.setBounds(130, 160, 360, 50);

        jLabel22.setText("Jumlah Cetak");
        jPanel6.add(jLabel22);
        jLabel22.setBounds(10, 220, 120, 20);
        jPanel6.add(jSpinnerJumlahCetak);
        jSpinnerJumlahCetak.setBounds(130, 220, 80, 28);

        panelPenjualan.add(jPanel6);
        jPanel6.setBounds(10, 10, 660, 310);

        jTabbedPane1.addTab("Penjualan", panelPenjualan);

        getContentPane().add(jTabbedPane1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 670, 350));

        btnSave.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/printer.png"))); // NOI18N
        btnSave.setText("Simpan");
        btnSave.setMargin(new java.awt.Insets(2, 2, 2, 2));
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });
        getContentPane().add(btnSave, new org.netbeans.lib.awtextra.AbsoluteConstraints(480, 360, -1, -1));

        btnKeluar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/resources/images/cancel.png"))); // NOI18N
        btnKeluar.setText("Keluar");
        btnKeluar.setMargin(new java.awt.Insets(2, 2, 2, 2));
        btnKeluar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnKeluarActionPerformed(evt);
            }
        });
        getContentPane().add(btnKeluar, new org.netbeans.lib.awtextra.AbsoluteConstraints(580, 360, -1, -1));

        setBounds(0, 0, 699, 424);
    }// </editor-fold>//GEN-END:initComponents

    private void txtAkunLabaDitahanKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtAkunLabaDitahanKeyReleased
        fn.lookup(evt, new Object[]{lblAkunLabaDitahan}, "select acc_no, coalesce(acc_name,'') as acc_name "
                + "from acc_coa where "
                + "acc_no||coalesce(acc_name,'') ilike '%" + txtAkunLabaDitahan.getText() + "%' "
                + "and active order by acc_no, acc_name", txtAkunLabaDitahan.getWidth() + lblAkunLabaDitahan.getWidth() + 20, 150);
    }//GEN-LAST:event_txtAkunLabaDitahanKeyReleased

    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
        udfSave();
    }//GEN-LAST:event_btnSaveActionPerformed

    private void btnKeluarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnKeluarActionPerformed
        this.dispose();
    }//GEN-LAST:event_btnKeluarActionPerformed

    private void formInternalFrameOpened(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_formInternalFrameOpened
        udfInitForm();
    }//GEN-LAST:event_formInternalFrameOpened

    private void txtKotaKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtKotaKeyReleased
        fn.lookup(evt, new Object[]{lblKota}, 
                "select id, coalesce(nama_kota,'') nama_kota \n" +
                "from m_kota where coalesce(nama_kota,'') ilike '%"+txtKota.getText()+"%' ", lblKota.getWidth()+txtKota.getWidth() + 20, 300);
    }//GEN-LAST:event_txtKotaKeyReleased

    private void udfInitForm() {
        //Informasi Perusahaan
        informasiPerusahaan = konfigurasiSistemDao.getInformasiPerusahaan();

        if (informasiPerusahaan != null) {
            txtNamaUsaha.setText(informasiPerusahaan.getNamaToko());
            txtAlamat1.setText(informasiPerusahaan.getAlamat1());
            txtAlamat2.setText(informasiPerusahaan.getAlamat2());
            txtKota.setText(String.valueOf(informasiPerusahaan.getIdKota()));
            lblKota.setText(informasiPerusahaan.getKota());
            txtTelp1.setText(informasiPerusahaan.getTelp1());
            txtTelp2.setText(informasiPerusahaan.getTelp2());
            txtEmail.setText(informasiPerusahaan.getEmail());
            txtAkunLabaDitahan.setText(informasiPerusahaan.getAkunLabaDitahan());
            if (informasiPerusahaan.getAkunLabaDitahan() != null && !informasiPerusahaan.getAkunLabaDitahan().equalsIgnoreCase("")) {
                lblAkunLabaDitahan.setText(coaDao.cariAccCoaByID(txtAkunLabaDitahan.getText()).getAcc_name());
            }
            chkTglServer.setSelected(informasiPerusahaan.isTglSystemDefault());
            chkStatusShift.setSelected(informasiPerusahaan.isStatusShift());
//                txtGudang.setText(String.valueOf(informasiPerusahaan.getIdGudangDefault()));
//                lblGudang.setText(gudangDao.cariByID(informasiPerusahaan.getIdGudangDefault()).getNama_gudang());
        }
        //Setting Penjualan
        settingPenjualan = konfigurasiSistemDao.getSettingPenjualan();

        if (settingPenjualan != null) {
            txtKetPembayaran.setText(settingPenjualan.getKetPembayaran());
            txtCatatanKaki.setText(settingPenjualan.getCatatanKaki());
            txtDisiapkanOleh.setText(settingPenjualan.getDisiapkanOleh());
            txtDibuatOleh.setText(settingPenjualan.getDibuatOleh());
            txtDiperiksaOleh.setText(settingPenjualan.getDiperiksaOleh());
            chkTampilkanHpp.setSelected(settingPenjualan.isTampilkanHpp());
            chkTutupDialogBayar.setSelected(settingPenjualan.isTutupDialogBayarPrint());
            jSpinnerJumlahCetak.setValue(settingPenjualan.getJumlahCetakFaktur());
        }

    }

    private boolean isNewInfoPerusahaan = true;
    private boolean isNewSettingPenjualan = true;

    private void udfSave() {
        konfigurasiSistemDao.simpanInformasiPerusahaan(informasiPerusahaan, new InformasiPerusahaan(
                txtNamaUsaha.getText(), txtAlamat1.getText(), txtAlamat2.getText(),
                GeneralFunction.udfGetInt(txtKota.getText()), lblKota.getText(), txtTelp1.getText(), txtTelp2.getText(),
                txtEmail.getText(), txtAkunLabaDitahan.getText(), chkTglServer.isSelected(), chkStatusShift.isSelected()));

        MainForm.sToko = txtNamaUsaha.getText();
        MainForm.sAlamat1 = txtAlamat1.getText();
        MainForm.sAlamat2 = txtAlamat2.getText();
        MainForm.sKota = txtKota.getText();
        MainForm.sTelp1 = txtTelp1.getText();
        MainForm.sTelp2 = txtTelp2.getText();
        MainForm.sEmail = txtEmail.getText();
        Konfigurasi.TAMPILKAN_HPP_PENJUALAN = chkTampilkanHpp.isSelected();
        Konfigurasi.TUTUP_DIALOG_PEMBAYARAN = chkTutupDialogBayar.isSelected();

        konfigurasiSistemDao.simpanSettingPenjualan(settingPenjualan, new SettingPenjualan(
                txtKetPembayaran.getText(), txtCatatanKaki.getText(), txtDisiapkanOleh.getText(),
                txtDibuatOleh.getText(), txtDiperiksaOleh.getText(), chkTampilkanHpp.isSelected(), 
                chkTutupDialogBayar.isSelected(), (Integer)jSpinnerJumlahCetak.getValue()));

        JOptionPane.showMessageDialog(this, "Update sukses!");
        this.dispose();

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnKeluar;
    private javax.swing.JButton btnSave;
    private javax.swing.JCheckBox chkStatusShift;
    private javax.swing.JCheckBox chkTampilkanHpp;
    private javax.swing.JCheckBox chkTglServer;
    private javax.swing.JCheckBox chkTutupDialogBayar;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSpinner jSpinnerJumlahCetak;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JLabel lblAkunLabaDitahan;
    private javax.swing.JLabel lblKota;
    private javax.swing.JPanel panelInformasiUsaha;
    private javax.swing.JPanel panelInformasiUsahaDetail;
    private javax.swing.JPanel panelPenjualan;
    private javax.swing.JTextField txtAkunLabaDitahan;
    private javax.swing.JTextField txtAlamat1;
    private javax.swing.JTextField txtAlamat2;
    private javax.swing.JTextArea txtCatatanKaki;
    private javax.swing.JTextField txtDibuatOleh;
    private javax.swing.JTextField txtDiperiksaOleh;
    private javax.swing.JTextField txtDisiapkanOleh;
    private javax.swing.JTextField txtEmail;
    private javax.swing.JTextArea txtKetPembayaran;
    private javax.swing.JTextField txtKota;
    private javax.swing.JTextField txtNamaUsaha;
    private javax.swing.JTextField txtTelp1;
    private javax.swing.JTextField txtTelp2;
    // End of variables declaration//GEN-END:variables

    public class MyKeyListener extends KeyAdapter {

        @Override
        public void keyTyped(java.awt.event.KeyEvent evt) {

//            if(getTableSource()==null)
//                return;
            if (evt.getSource() instanceof JTextField
                    && ((JTextField) evt.getSource()).getName() != null
                    && ((JTextField) evt.getSource()).getName().equalsIgnoreCase("textEditor")) {
                fn.keyTyped(evt);

            }

        }

        public void keyPressed(KeyEvent evt) {
            Component ct = KeyboardFocusManager.getCurrentKeyboardFocusManager().getPermanentFocusOwner();
            int keyKode = evt.getKeyCode();
            switch (keyKode) {
                case KeyEvent.VK_ENTER: {
                    if (!(ct instanceof JTable)) {
                        if (!fn.isListVisible()) {
                            Component c = findNextFocus();
                            if (c == null) {
                                return;
                            }
                            c.requestFocus();
                        } else {
                            fn.lstRequestFocus();
                        }
                    }
                    break;
                }
                case KeyEvent.VK_DOWN: {
                    if (!(ct.getClass().getSimpleName().equalsIgnoreCase("JTABLE"))) {
                        if (!fn.isListVisible()) {
                            Component c = findNextFocus();
                            if (c == null) {
                                return;
                            }
                            c.requestFocus();
                        } else {
                            fn.lstRequestFocus();
                        }
                        break;
                    }
                }

                case KeyEvent.VK_UP: {
                    if (!(evt.getSource() instanceof JTable)) {
                        Component c = findPrevFocus();
                        c.requestFocus();
                    }
                    break;
                }
                case KeyEvent.VK_ESCAPE: {
                    dispose();
                    break;
                }

            }
        }

//        @Override
//        public void keyReleased(KeyEvent evt){
//            if(evt.getSource().equals(txtDisc)||evt.getSource().equals(txtQty)||evt.getSource().equals(txtUnitPrice))
//                GeneralFunction.keyTyped(evt);
//        }
        public Component findNextFocus() {
            // Find focus owner
            Component c = KeyboardFocusManager.getCurrentKeyboardFocusManager().getFocusOwner();
            Container root = c == null ? null : c.getFocusCycleRootAncestor();

            if (root != null) {
                FocusTraversalPolicy policy = root.getFocusTraversalPolicy();
                Component nextFocus = policy.getComponentAfter(root, c);
                if (nextFocus == null) {
                    nextFocus = policy.getDefaultComponent(root);
                }
                return nextFocus;
            }
            return null;
        }

        public Component findPrevFocus() {
            // Find focus owner
            Component c = KeyboardFocusManager.getCurrentKeyboardFocusManager().getFocusOwner();
            Container root = c == null ? null : c.getFocusCycleRootAncestor();

            if (root != null) {
                FocusTraversalPolicy policy = root.getFocusTraversalPolicy();
                Component prevFocus = policy.getComponentBefore(root, c);
                if (prevFocus == null) {
                    prevFocus = policy.getDefaultComponent(root);
                }
                return prevFocus;
            }
            return null;
        }
    }

    private FocusListener txtFocusListener = new FocusListener() {
        public void focusGained(FocusEvent e) {
            if (e.getSource() instanceof JTextField || e.getSource() instanceof JFormattedTextField) {
                ((JTextField) e.getSource()).setBackground(Color.YELLOW);
                if ((e.getSource() instanceof JTextField && ((JTextField) e.getSource()).getName() != null && ((JTextField) e.getSource()).getName().equalsIgnoreCase("textEditor"))) {
                    ((JTextField) e.getSource()).setSelectionStart(0);
                    ((JTextField) e.getSource()).setSelectionEnd(((JTextField) e.getSource()).getText().length());

                }
            }
        }

        public void focusLost(FocusEvent e) {
            if (e.getSource().getClass().getSimpleName().equalsIgnoreCase("JTextField")
                    || e.getSource().getClass().getSimpleName().equalsIgnoreCase("JFormattedTextField")) {
                ((JTextField) e.getSource()).setBackground(Color.WHITE);
            }
        }
    };

}
